<?php defined('ABSPATH') || exit;


if (!class_exists('jkdevkit')):

    /* include framework main class */
    require_once dirname(__FILE__) . '/jkdevkit/jkdevkit.php';

endif;

/* theme activation trigger */
$theme_activation = get_option(THEME_SLUG . '_jkd_activation');

/* check theme activation */
if ($theme_activation):

    /* include class-tgm-plugin-activation */
    require_once('class-tgm-plugin-activation.php');

endif;

/**
 * Class JKD_Theme
 */
class JKD_Theme
{

    /**
     * @var
     */
    public $slug;

    /**
     * @var
     */
    public $url;

    /**
     * @var
     */
    public $item_url;

    /**
     * @var
     */
    public $author_url;

    /**
     * @var
     */
    public $default_tab;

    /**
     * @var
     */
    public $tabs;

    /**
     * @var
     */
    public $name;

    /**
     * @var
     */
    public $copyright;

    /**
     * @var
     */
    public $author;

    public $templates_path;

    /**
     * @var
     */
    public $id;

    /**
     * @var
     */
    public $version;

    /**
     * @var
     */
    public $menu_title;

    /**
     * @var
     */
    public $capability;

    /**
     * @var
     */
    public $icon_svg;

    /**
     * @var
     */
    public $logo_svg;

    /**
     * @var
     */
    public $position;

    /**
     * @var
     */
    public $additional_links;

    /**
     * @var
     */
    public $social_links;

    public $assets_url;

    /**
     * @var
     */
    public static $instance;

    /**
     * @var string
     */
    protected $update_repo_url;

    /**
     * @var string
     */
    protected $update_local_path;

    /**
     * @var string
     */
    protected $update_repo_slug;

    public static $activation = false;

    /**
     * @return mixed
     */
    public function getTemplatesPath()
    {
        return $this->templates_path;
    }

    /**
     * @param mixed $templates_path
     */
    public function setTemplatesPath($templates_path): void
    {
        $this->templates_path = $templates_path;
    }

    /**
     * @return mixed
     */
    public function getSlug()
    {
        return $this->slug;
    }

    /**
     * @param mixed $slug
     */
    public function setSlug($slug): void
    {
        $this->slug = $slug;
    }

    /**
     * @return mixed
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * @param mixed $url
     */
    public function setUrl($url): void
    {
        $this->url = $url;
    }

    /**
     * @return mixed
     */
    public function getItemUrl()
    {
        return $this->item_url;
    }

    /**
     * @param mixed $item_url
     */
    public function setItemUrl($item_url): void
    {
        $this->item_url = $item_url;
    }

    /**
     * @return mixed
     */
    public function getAuthorUrl()
    {
        return $this->author_url;
    }

    /**
     * @param mixed $author_url
     */
    public function setAuthorUrl($author_url): void
    {
        $this->author_url = $author_url;
    }

    /**
     * @return mixed
     */
    public function getDefaultTab()
    {
        return $this->default_tab;
    }

    /**
     * @param mixed $default_tab
     */
    public function setDefaultTab($default_tab): void
    {
        $this->default_tab = $default_tab;
    }

    /**
     * @return mixed
     */
    public function getTabs()
    {
        return $this->tabs;
    }

    /**
     * @param mixed $tabs
     */
    public function setTabs($tabs): void
    {
        $this->tabs = $tabs;
    }

    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * @param mixed $name
     */
    public function setName($name): void
    {
        $this->name = $name;
    }

    /**
     * @return mixed
     */
    public function getCopyright()
    {
        return $this->copyright;
    }

    /**
     * @param mixed $copyright
     */
    public function setCopyright($copyright): void
    {
        $this->copyright = $copyright;
    }

    /**
     * @return mixed
     */
    public function getAuthor()
    {
        return $this->author;
    }

    /**
     * @param mixed $author
     */
    public function setAuthor($author): void
    {
        $this->author = $author;
    }

    /**
     * @return mixed
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param mixed $id
     */
    public function setId($id): void
    {
        $this->id = $id;
    }

    /**
     * @return mixed
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * @param mixed $version
     */
    public function setVersion($version): void
    {
        $this->version = $version;
    }

    /**
     * @return mixed
     */
    public function getMenuTitle()
    {
        return $this->menu_title;
    }

    /**
     * @param mixed $menu_title
     */
    public function setMenuTitle($menu_title): void
    {
        $this->menu_title = $menu_title;
    }

    /**
     * @return mixed
     */
    public function getCapability()
    {
        return $this->capability;
    }

    /**
     * @param mixed $capability
     */
    public function setCapability($capability): void
    {
        $this->capability = $capability;
    }

    /**
     * @return mixed
     */
    public function getIconSvg()
    {
        return $this->icon_svg;
    }

    /**
     * @param mixed $icon_svg
     */
    public function setIconSvg($icon_svg): void
    {
        $this->icon_svg = $icon_svg;
    }

    /**
     * @return mixed
     */
    public function getLogoSvg()
    {
        return $this->logo_svg;
    }

    /**
     * @param mixed $logo_svg
     */
    public function setLogoSvg($logo_svg): void
    {
        $this->logo_svg = $logo_svg;
    }

    /**
     * @return mixed
     */
    public function getPosition()
    {
        return $this->position;
    }

    /**
     * @param mixed $position
     */
    public function setPosition($position): void
    {
        $this->position = $position;
    }

    /**
     * @return mixed
     */
    public function getAdditionalLinks()
    {
        return $this->additional_links;
    }

    /**
     * @param mixed $additional_links
     */
    public function setAdditionalLinks($additional_links): void
    {
        $this->additional_links = $additional_links;
    }

    /**
     * @return mixed
     */
    public function getSocialLinks()
    {
        return $this->social_links;
    }

    /**
     * @param mixed $social_links
     */
    public function setSocialLinks($social_links): void
    {
        $this->social_links = $social_links;
    }

    /**
     * @return mixed
     */
    public function getAssetsUrl()
    {
        return $this->assets_url;
    }

    /**
     * @param mixed $assets_url
     */
    public function setAssetsUrl($assets_url): void
    {
        $this->assets_url = $assets_url;
    }

    /**
     * @return mixed
     */
    public static function getInstance(): jkdevkit
    {
        return self::$instance;
    }

    /**
     * @param mixed $instance
     */
    public static function setInstance(jkdevkit $instance): void
    {
        self::$instance = $instance;
    }

    /**
     * @return string
     */
    public function getUpdateRepoUrl(): string
    {
        return $this->update_repo_url;
    }

    /**
     * @param string $update_repo_url
     */
    public function setUpdateRepoUrl(string $update_repo_url): void
    {
        $this->update_repo_url = $update_repo_url;
    }

    /**
     * @return string
     */
    public function getUpdateLocalPath(): string
    {
        return $this->update_local_path;
    }

    /**
     * @param string $update_local_path
     */
    public function setUpdateLocalPath(string $update_local_path): void
    {
        $this->update_local_path = $update_local_path;
    }

    /**
     * @return string
     */
    public function getUpdateRepoSlug(): string
    {
        return $this->update_repo_slug;
    }

    /**
     * @param string $update_repo_slug
     */
    public function setUpdateRepoSlug(string $update_repo_slug): void
    {
        $this->update_repo_slug = $update_repo_slug;
    }

    /**
     * @return bool
     */
    public static function isActivation(): bool
    {
        return self::$activation;
    }

    /**
     * @param bool $activation
     */
    public static function setActivation(bool $activation): void
    {
        self::$activation = $activation;
    }

    /**
     * @param $args
     */
    public function __construct($args = array())
    {

        /* setup  repo slug */
        if (!empty($args['update_repo_slug'])):

            /* new value */
            $this->setUpdateRepoSlug($args['update_repo_slug']);

        endif;

        /* setup  local update path */
        if (!empty($args['update_local_path'])):

            /* new value */
            $this->setUpdateLocalPath($args['update_local_path']);

        endif;

        /* setup  repo url */
        if (!empty($args['update_repo_url'])):

            /* new value */
            $this->setUpdateRepoUrl($args['update_repo_url']);


        endif;

        /* setup url */
        if (!empty($args['url'])):

            $this->setUrl($args['url']);

        endif;

        /* setup item url */
        if (!empty($args['item_url'])):

            $this->setItemUrl($args['item_url']);

        endif;

        /* setup templates path */
        if (!empty($args['templates_path'])):

            $this->setTemplatesPath($args['templates_path']);

        endif;

        /* setup slug */
        if (!empty($args['slug'])):

            $this->setSlug($args['slug']);

        endif;

        /* setup id */
        if (!empty($args['id'])):

            $this->setId($args['id']);

        endif;

        /* setup name */
        if (!empty($args['name'])):

            $this->setName($args['name']);

        endif;

        /* setup copyright */
        if (!empty($args['copyright'])):

            $this->setCopyright($args['copyright']);

        endif;

        /* setup author_url */
        if (!empty($args['author_url'])):

            $this->setAuthorUrl($args['author_url']);

        endif;

        /* setup tabs */
        if (!empty($args['tabs'])):

            $this->setTabs($args['tabs']);

        endif;

        /* setup default tab */
        if (!empty($args['default_tab'])):

            $this->setDefaultTab($args['default_tab']);

        endif;

        /* setup author */
        if (!empty($args['author'])):

            $this->setAuthor($args['author']);

        endif;

        /* setup version */
        if (!empty($args['version'])):

            $this->setVersion($args['version']);

        endif;

        /* setup menu_title */
        if (!empty($args['menu_title'])):

            $this->setMenuTitle($args['menu_title']);

        endif;

        /* setup capability */
        if (!empty($args['capability'])):

            $this->setCapability($args['capability']);

        endif;

        /* setup icon svg */
        if (!empty($args['icon_svg'])):

            $this->setIconSvg($args['icon_svg']);

        else:

            $this->setIconSvg($args['logo_svg']);

        endif;

        /* setup logo svg */
        if (!empty($args['logo_svg'])):

            $this->setLogoSvg($args['logo_svg']);

        else:

            $this->setIconSvg($args['icon_svg']);

        endif;

        /* setup position */
        if (!empty($args['position'])):

            $this->setPosition($args['position']);

        endif;

        /* setup additional_links */
        if (!empty($args['additional_links'])):

            $this->setAdditionalLinks($args['additional_links']);

        endif;

        /* setup social_links */
        if (!empty($args['social_links'])):

            $this->setSocialLinks($args['social_links']);

        endif;

        /* setup assets url */
        if (!empty($args['assets_url'])):

            /* new value */
            $this->setAssetsUrl($args['assets_url']);

        endif;

        /* check if jkd framework is exists */
        if (class_exists('jkdevkit')):

            /* new instance of jkdevkit */
            self::$instance = new jkdevkit(array(
                /* item slug */
                'slug' => $this->slug,
                /* item id */
                'id' => $this->id,
                /* item version */
                'version' => $this->version,
                /* item name */
                'name' => $this->name,
                /* item author */
                'author' => $this->author,
                /* folder url */
                'url' => trailingslashit(get_template_directory_uri()),
                /* templates path */
                'templates_path' => $this->templates_path,
                /* item tabs callback */
                'tabs_callback' => function ($tab) {


                }
            ));

        endif;

        /* init theme */
        $this->init_theme();

    }

    /**
     * init theme
     */
    protected function init_theme()
    {

        /* init textdomain */
        add_action('init', [$this, 'i18n']);

        /* init sidebar area */
        add_action('widgets_init', [$this, 'init_sidebar_area']);

        /* init navigation area */
        add_action('after_setup_theme', [$this, 'init_navigation_area']);

        /* theme setup values */
        add_action('after_setup_theme', [$this, 'theme_setup']);

        /* enqueue lib styles */
        add_action('wp_enqueue_scripts', [$this, 'enqueue_styles_lib']);

        /* enqueue theme styles */
        add_action('wp_enqueue_scripts', [$this, 'enqueue_styles_theme']);

        /* enqueue lib scripts */
        add_action('wp_enqueue_scripts', [$this, 'enqueue_scripts_lib']);

        /* enqueue theme scripts */
        add_action('wp_enqueue_scripts', [$this, 'enqueue_scripts_theme']);

        /* enqueue inline theme styles */
        add_action('wp_enqueue_scripts', [$this, 'inline_enqueue_styles']);

        /* add admin menu page for theme info */
        add_action('admin_menu', [$this, 'add_admin_menu_page'], 0);

        /* add pingback link to <head> */
        add_action('wp_head', [$this, 'pingback_header']);

        /* remove sitename from the document title */
        add_filter('document_title_parts', [$this, 'remove_sitename_from_title'], 10, 1);

        /* Update comment form fields */
        add_filter('comment_form_default_fields', [$this, 'comment_form_default_fields']);

        /* Update comment form textarea */
        add_filter('comment_form_field_comment', [$this, 'comment_form_field_comment']);

        /* change default comment template */
        add_filter('wp_list_comments_args', [$this, 'comments_args']);

        if (class_exists('Woocommerce')):

            $this->init_woocommerce();

        endif;

        /* theme activation trigger

                  It is auto-updated and checked on our server, so just deleting this check will not work

                   */
        /* get current plugin activation toggle */
        $activation = get_option($this->slug . '_jkd_activation');

        /* get current plugin activation data */
        $activation_data = get_option($this->slug . '_jkd_activation_data');

        /* Simple theme activation check */
        if ($activation
            && !empty($activation_data->supported_until)
            && !empty($activation_data->code)
            && !empty($activation_data->sold_at)):

            /* init theme updates */
            add_action('init', [$this, 'init_theme_updates'], 1);

            /* check if exists ocdi */
            if (class_exists('OCDI_Plugin')):

                /* disable ocdi branding */
                add_filter('pt-ocdi/disable_pt_branding', '__return_true');

                /* ocdi after import */
                add_action('pt-ocdi/after_import', [$this, 'ocdi_after_import_setup']);

                /* ocdi import files */
                add_filter('pt-ocdi/import_files', [$this, 'ocdi_import_files']);

                /* init ocdi config */
                add_filter('ocdi/plugin_page_setup', [$this, 'ocdi_plugin_page_setup']);

                /* for low settings */
                add_filter('ocdi/time_for_one_ajax_call', function () {
                    return 10;
                });

                add_filter('ocdi/regenerate_thumbnails_in_content_import', '__return_false');

            endif;

            /* check if exists tgma */
            if (class_exists('TGM_Plugin_Activation')):

                /* tgm required plugins */
                add_action('tgmpa_register', [$this, 'register_required_plugins']);

            endif;

        endif;

    }

    /**
     * @return void
     */
    public function init_woocommerce()
    {

        /* set woo related products */
        add_filter('woocommerce_output_related_products_args', [$this, 'output_related_products'], 20);

        add_filter('woocommerce_upsell_display_args', [$this, 'output_upsell_products'], 20);

        add_filter('woocommerce_cross_sells_total', [$this, 'output_cross_sells_products'], 20);

        add_action('wp_ajax_nopriv_jkd_shop_load_more', [$this, 'shop_load_more']);

        add_action('wp_ajax_jkd_shop_load_more', [$this, 'shop_load_more']);

        add_filter('loop_shop_per_page', [$this, 'set_products_per_page'], 99);

        add_filter('loop_shop_columns', [$this, 'set_columns_count'], 1, 10);

        remove_action('woocommerce_shop_loop_item_title', 'woocommerce_template_loop_product_title', 10);

        add_action('woocommerce_shop_loop_item_title', [$this, 'change_products_loop_title'], 10);

        remove_action('woocommerce_archive_description', 'woocommerce_taxonomy_archive_description', 10);

        add_action('woocommerce_archive_description', [$this, 'woocommerce_output_all_notices'], 10);

        remove_action('woocommerce_after_shop_loop_item', 'woocommerce_template_loop_add_to_cart', 10);

        add_action('woocommerce_after_shop_loop_item_title', [$this, 'woocommerce_template_loop_add_to_cart'], 10);

        remove_action('woocommerce_after_shop_loop_item_title', 'woocommerce_template_loop_rating', 5);

        add_action('woocommerce_after_shop_loop_item_title', [$this, 'woocommerce_template_loop_rating'], 5);

        /* override woo billing checkout fields */
        add_filter('woocommerce_checkout_fields', [$this, 'override_billing_checkout_fields'], 20, 1);

        /* override woo address checkout fields */
        add_filter('woocommerce_default_address_fields', [$this, 'override_default_address_checkout_fields'], 20, 1);

        /* override woo order button text */
        add_filter('woocommerce_order_button_text', [$this, 'override_order_button_text']);

        /* disable woo select styles / scripts */
        add_action('wp_enqueue_scripts', function () {
            wp_dequeue_style('select2');
            wp_dequeue_script('select2');
            wp_dequeue_script('selectWoo');
        }, 11);

        remove_action('woocommerce_before_shop_loop', 'woocommerce_output_all_notices', 10);

        remove_action('woocommerce_before_shop_loop', 'woocommerce_catalog_ordering', 30);

        remove_action('woocommerce_after_single_product_summary', 'woocommerce_upsell_display', 15);

        remove_action('woocommerce_after_single_product_summary', 'woocommerce_output_related_products', 20);

        remove_action('woocommerce_before_main_content', 'woocommerce_breadcrumb', 20);

        remove_action('woocommerce_before_shop_loop', 'woocommerce_result_count', 20);

    }

    /**
     * pingback header
     */
    public function pingback_header()
    {

        /* check is singular && pings open */
        if (is_singular() && pings_open()) :

            ?>

            <!-- pingback url -->
            <link rel="pingback" href="<?php echo esc_url(get_bloginfo('pingback_url')); ?>">

        <?php

        endif;

    }

    /**
     * init theme updates
     */
    public function init_theme_updates()
    {

        /* check if auto-update checker exists */
        if (class_exists('Puc_v4_Factory')):

            /* builder auto update config */
            Puc_v4_Factory::buildUpdateChecker(
            /* update url */
                $this->getUpdateRepoUrl(),
                /* local path */
                $this->getUpdateLocalPath(),
                /* repo slug */
                $this->getUpdateRepoSlug()
            );

        endif;

    }

    /**
     * register required theme plugins
     */
    public function register_required_plugins()
    {

        /* plugins array */
        $plugins = array(
            /* Qreatix Core Plugin */
            array(
                'name' => 'Qreatix Core Plugin',
                'slug' => 'jkd-wp-qreatix-core',
                'source' => $this->assets_url . '/plugin/jkd-wp-qreatix-core-1.9.6.zip',
                'required' => true,
                'version' => '1.9.6',
                'force_activation' => false,
                'force_deactivation' => false,
            ),
            /* Advanced Custom Fields PRO */
            array(
                'name' => 'Advanced Custom Fields PRO',
                'slug' => 'advanced-custom-fields-pro',
                'source' => $this->assets_url . '/extra/advanced-custom-fields-pro.zip',
                'required' => true,
                'version' => 1.0,
                'force_activation' => false,
                'force_deactivation' => false,
            ),
            /* Advanced Custom Fields PRO */
            array(
                'name' => 'Slider Revolution',
                'slug' => 'revslider',
                'source' => $this->assets_url . '/extra/revslider.zip',
                'required' => false,
                'version' => 1.0,
                'force_activation' => false,
                'force_deactivation' => false,
            ),
            /* Booked */
            array(
                'name' => 'Booked',
                'slug' => 'booked',
                'source' => $this->assets_url . '/extra/booked.zip',
                'required' => false,
                'version' => 1.0,
                'force_activation' => false,
                'force_deactivation' => false,
            ),
            /* Kirki Customizer Framework */
            array(
                'name' => 'Kirki',
                'slug' => 'kirki',
                'required' => true,
            ),
            /* Elementor */
            array(
                'name' => 'Elementor',
                'slug' => 'elementor',
                'required' => false,
            ),
            /* Woocommerce */
            array(
                'name' => 'WooCommerce',
                'slug' => 'woocommerce',
                'required' => false,
            ),
            /* The Events Calendar */
            array(
                'name' => 'The Events Calendar',
                'slug' => 'the-events-calendar',
                'required' => false,
            ),
            /* Event Tickets */
            array(
                'name' => 'Event Tickets',
                'slug' => 'event-tickets',
                'required' => false,
            ),
            /* Contact Form 7 */
            array(
                'name' => 'Contact Form 7',
                'slug' => 'contact-form-7',
                'required' => false,
            ),
            /* Mailchimp for WordPress */
            array(
                'name' => 'Mailchimp for WordPress',
                'slug' => 'mailchimp-for-wp',
                'required' => false,
            ),
            /* OCDI */
            array(
                'name' => 'One Click Demo Import',
                'slug' => 'one-click-demo-import',
                'required' => false,
            ),
            /* PW WooCommerce Gift Cards */
            array(
                'name' => 'PW WooCommerce Gift Cards',
                'slug' => 'pw-woocommerce-gift-cards',
                'required' => false,
            ),
            /* TI WooCommerce Wishlist */
            array(
                'name' => 'TI WooCommerce Wishlist',
                'slug' => 'ti-woocommerce-wishlist',
                'required' => false,
            ),
            /* WOOF - WooCommerce Products Filter */
            array(
                'name' => 'WOOF - WooCommerce Products Filter',
                'slug' => 'woocommerce-products-filter',
                'required' => false,
            ),
        );

        /* tgm config */
        $config = array(
            'id' => 'qreatix',
            'has_notices' => true,
            'dismissable' => true,
            'is_automatic' => true,
        );

        /* init tgmpa */
        tgmpa($plugins, $config);

    }

    /**
     * @return array
     */
    public function ocdi_import_files()
    {

        /* return main demo */
        return array(

            /* (#0) main demo */
            array(
                /* demo name */
                'import_file_name' => esc_html('Qreatix'),
                /* demo XML (content) */
                'import_file_url' => self::getAssetsUrl() . 'demo/demo.xml',
                /* demo dat (customizer settings) */
                'import_customizer_file_url' => self::getAssetsUrl() . 'demo/demo.dat',
                /* import widgets */
                'import_widget_file_url' => self::getAssetsUrl() . 'demo/demo.wie',
                /* preview */
                'preview_url' => trailingslashit(self::getAssetsUrl()) . 'demo/demo.jpg',
            ),

        );

    }

    /**
     * @param $selected_import
     */
    public function ocdi_after_import_setup($selected_import)
    {

        /* define global wp rewrite */
        global $wp_rewrite;

        /* get navigation menu */
        $navigation_menu = get_term_by('name', 'Menu 1', 'nav_menu');

        /* get error menu */
        $error_menu = get_term_by('name', 'Menu 2', 'nav_menu');

        /* update rewrite rules to false */
        update_option("rewrite_rules", false);

        /* get front page id */
        $front_page_id = get_page_by_title('Tiles Grid');

        /* set menu navigation */
        set_theme_mod('nav_menu_locations',
            array(
                'primary_menu' => $navigation_menu->term_id,
            )
        );

        /* set error navigation */
        set_theme_mod('nav_menu_locations',
            array(
                'error_menu' => $error_menu->term_id,
            )
        );

        /* set permalink structure */
        $wp_rewrite->set_permalink_structure('/%postname%/');

        /* flush permalinks */
        $wp_rewrite->flush_rules(true);

        /* set front page */
        update_option('page_on_front', $front_page_id->ID, false);

    }

    /**
     * @param $existing_mimes
     *
     * @return mixed
     */
    public function custom_upload_extensions($existing_mimes)
    {

        /*

        added dat to current mimes array
        used for .dat customizer import (Kirki settings)

        */
        $existing_mimes['dat'] = 'text/plain';

        /*

        added wie to current mimes array
        used for .wie widgets import

        */
        $existing_mimes['wie'] = 'text/plain';

        /* return mimes with new ones */
        return $existing_mimes;


    }

    /**
     * init theme translation (i18n)
     */
    public function i18n()
    {

        /* register theme text domain */
        load_theme_textdomain('qreatix', get_template_directory() . '/lang');

    }

    /**
     * @param $default_settings
     *
     * @return mixed
     */
    public function ocdi_plugin_page_setup($default_settings)
    {

        /* default parent page for ocdi */
        $default_settings['parent_slug'] = $this->slug;

        return $default_settings;

    }

    /**
     * enqueue lib styles
     */
    public function enqueue_styles_lib()
    {

        /* check if remix icons styles exists */
        if (!wp_style_is('jkd-remix-icons')):

            /* enqueue remix icons styles */
            wp_enqueue_style('jkd-remix-icons', get_template_directory_uri() . '/assets/css/lib/remixicon.min.css');

        endif;

    }

    /**
     * enqueue theme styles
     */
    public function enqueue_styles_theme()
    {

        /* get rtl global var from the customizer */
        $rtl = get_theme_mod('general-rtl-toggle', false);

        /* assets suffixes array */
        $suffix = array();

        /* $_GET query for the rtl */
        if (!empty($_GET['rtl'])):

            /* get rtl var from the $_GET query */
            $rtl = $_GET['rtl'];

        endif;

        /* if rtl setting is true */
        if ($rtl):

            /* added .rtl to assets suffixes */
            array_push($suffix, '.rtl');

        endif;

        /* implode all suffixes */
        $suffix = implode('', $suffix);

        /* check if default-fonts styles exists */
        if (!wp_style_is('jkd-theme-default-fonts') && !class_exists('JKD_Core')):

            /* enqueue default-fonts styles */
            wp_enqueue_style('jkd-theme-default-fonts', get_template_directory_uri() . '/assets/css/theme/default-fonts.css');

        endif;

        /* check if sidebar styles exists */
        if (!wp_style_is('jkd-theme-sidebar')):

            /* enqueue sidebar styles */
            wp_enqueue_style('jkd-theme-sidebar', get_template_directory_uri() . '/assets/css/theme/sidebar' . $suffix . '.css');

        endif;

        /* check if default styles exists */
        if (!wp_style_is('jkd-theme-default') && !class_exists('JKD_Core')):

            /* enqueue default styles */
            wp_enqueue_style('jkd-theme-default', get_template_directory_uri() . '/assets/css/theme/default' . $suffix . '.css');

        endif;

        /* check if woocommerce styles exists */
        if (!wp_style_is('jkd-theme-woocommerce', 'registered')):

            /* enqueue woocommerce styles */
            wp_register_style('jkd-theme-woocommerce', get_template_directory_uri() . '/assets/css/theme/woocommerce' . $suffix . '.css');

        endif;

        /* check if main styles exists */
        if (!wp_style_is('jkd-theme-main')):

            /* enqueue main styles */
            wp_enqueue_style('jkd-theme-main', get_template_directory_uri() . '/assets/css/theme/main' . $suffix . '.css');

        endif;

    }

    /**
     * enqueue theme scripts
     */
    public function enqueue_scripts_lib()
    {

        /* check if easyzoom scripts exists */
        if (!wp_script_is('easyzoom')):

            /* enqueue easyzoom scripts */
            wp_register_script('easyzoom', get_template_directory_uri() . '/assets/js/lib/easyzoom.min.js', array('jquery', 'imagesloaded'),
                $this->version, true);

        endif;

        /* check if gsap scripts exists */
        if (!wp_script_is('gsap')):

            /* enqueue gsap scripts */
            wp_enqueue_script('gsap', get_template_directory_uri() . '/assets/js/lib/gsap.min.js', array('jquery', 'imagesloaded'),
                $this->version, true);

        endif;

    }

    /**
     * enqueue theme scripts
     */
    public function enqueue_scripts_theme()
    {

        /* check if singular || comments_open || thread_comments option === true */
        if (is_singular() && comments_open() && get_option('thread_comments')) :

            /* enqueue comment-reply script */
            wp_enqueue_script('comment-reply');

        endif;

        /* check if woocommerce scripts exists */
        if (!wp_script_is('jkd-theme-woocommerce', 'registered')):

            /* enqueue woocommerce scripts */
            wp_register_script('jkd-theme-woocommerce', get_template_directory_uri() . '/assets/js/theme/woocommerce.js', array('jquery', 'imagesloaded'),
                $this->version, true);

        endif;

        /* check if main scripts exists */
        if (!wp_script_is('jkd-theme-main') && !class_exists('JKD_Core')):

            /* enqueue main scripts */
            wp_enqueue_script('jkd-theme-main', get_template_directory_uri() . '/assets/js/theme/main.js', array('jquery', 'imagesloaded'),
                $this->version, true);

        endif;

    }

    /**
     * inline styles
     */
    public function inline_enqueue_styles()
    {

        /* shop items offset */
        $offset = get_theme_mod('shop-items-offset', esc_attr(15));

        /* check if offset is not empty */
        if (!empty($_GET['offset'])):

            /*  */
            $offset = $_GET['offset'];

        endif;

        $inline_css = "
        
        .shop-loop-wrapper .products{
           margin: -{$offset}px!important;
        }
                
        ";

        wp_add_inline_style('jkd-theme-main', $inline_css);

    }

    /**
     * init navigation area
     */
    public function init_navigation_area()
    {

        /* register primary nav menu (navigation area) */
        register_nav_menus(array(
            'primary_menu' => esc_html__('Navigation Menu', 'qreatix'),
        ));

        /* check if core plugin exists */
        if (class_exists('JKD_Core')):

            /* register error nav menu (404 page area) */
            register_nav_menus(array(
                'error_menu' => esc_html__('Error Menu', 'qreatix'),
            ));

        endif;

    }

    /**
     * init sidebar area
     */
    public function init_sidebar_area()
    {

        /* check if core class and Woo exists */
        if (class_exists('JKD_Core') && class_exists('WooCommerce')):

            /* register shop sidebar */
            register_sidebar(array(
                'name' => esc_html__('Shop filters sidebar', 'qreatix'),
                'id' => 'shop-filters-sidebar',
                'description' => esc_html__('Shop filters sidebar', 'qreatix'),
                'before_widget' => '<div class="sidebar-widget-wrapper"><div id="%1$s" class="sidebar-widget %2$s" >',
                'after_widget' => '</div></div>',
                'before_title' => '<h6 class="widget-title">',
                'after_title' => '</h6>',
            ));

        endif;

        /* register default blog sidebar */
        register_sidebar(array(
            'name' => esc_html__('Blog sidebar', 'qreatix'),
            'id' => 'blog-sidebar',
            'description' => esc_html__('Blog sidebar', 'qreatix'),
            'before_widget' => '<div class="overflow-wrapper sidebar-widget-wrapper"><div id="%1$s" class="sidebar-widget %2$s" >',
            'after_widget' => '</div></div>',
            'before_title' => '<h6 class="widget-title">',
            'after_title' => '</h6>',
        ));

    }

    /**
     * theme setup
     */
    public function theme_setup()
    {

        /* add editor styles */
        add_editor_style();

        /* add automatic-feed-links support */
        add_theme_support('automatic-feed-links');

        /* add post-thumbnails support */
        add_theme_support('post-thumbnails');

        /* add html5 support */
        add_theme_support('html5', array('comment-list', 'comment-form', 'search-form', 'gallery', 'caption'));

        /* add customize-selective-refresh-widgets support */
        add_theme_support('customize-selective-refresh-widgets');

        /* add post-formats support */
        add_theme_support('post-formats', array('video', 'gallery', 'quote', 'aside', 'image', 'link', 'audio'));

        /* add title-tag support */
        add_theme_support("title-tag");

        /* add editor-styles support */
        add_theme_support('editor-styles');

        /* check if WooCommerce exists */
        if (class_exists('WooCommerce')):

            /* add woocommerce support */
            add_theme_support('woocommerce');

        endif;

        /* check if content width exists */
        if (!isset($content_width)):

            /* default content width */
            $content_width = 1200;

        endif;

    }


    /**
     * @param $fields
     *
     * @return mixed
     */
    public function comment_form_default_fields($fields)
    {

        if (!class_exists('WooCommerce') || class_exists('WooCommerce') && !is_product()):

            /* get current commenter */
            $commenter = wp_get_current_commenter();

            /* get requite name email */
            $req = get_option('require_name_email');

            /* set aria req */
            $aria_req = $req ? "aria-required='true'" : '';

            /* set new author field */
            $fields['author'] = '<div class="input-wrapper"><p class="comment-form-author input-field-wrapper">
            <input id="author" 
            class="input-field jkd-input"
            name="author" 
            type="text" 
            placeholder="' . esc_attr__("Jonathan Doe", "qreatix") . '" 
            value="' . esc_attr($commenter['comment_author']) . '" 
            size="30" ' . $aria_req . ' /></p>';

            /* set new email field */
            $fields['email'] = '<p class="comment-form-email input-field-wrapper">
            <input id="email" 
            class="input-field jkd-input"
            name="email" 
            type="email" 
            placeholder="' . esc_attr("example@domain.com") . '" 
            value="' . esc_attr($commenter['comment_author_email']) . '" 
            size="30" ' . $aria_req . ' /></p>';

            /* set new website url field */
            $fields['url'] = '<p class="comment-form-url input-field-wrapper">
            <input id="url" 
            class="input-field jkd-input"
            name="url" 
            type="url"  
            placeholder="' . esc_attr("http://example.com") . '" 
            value="' . esc_attr($commenter['comment_author_url']) . '" 
            size="30" /></p></div>';

        endif;

        /* return modified fields */
        return $fields;

    }

    /**
     * @param $comment_field
     *
     * @return string
     */
    public function comment_form_field_comment($comment_field)
    {

        if (!class_exists('WooCommerce') || class_exists('WooCommerce') && !is_product()):

            /* set new comment field */
            $comment_field = '<div class="comment-form-textarea">
            <textarea required id="comment" 
            name="comment" 
            class="jkd-textarea"
            placeholder="' . esc_attr__("Comment", "qreatix") . '" 
            aria-required="true"></textarea></div>';

        endif;

        /* return modified field */
        return $comment_field;

    }

    /**
     * @param $args
     *
     * @return mixed
     */
    public function comments_args($args)
    {

        if (!class_exists('WooCommerce') || class_exists('WooCommerce') && !is_product()):

            /* rewrite comments callback */
            $args['callback'] = function ($comment, $depth, $args) {

                /* custom comment template */
                $this->comment_template($comment, $depth, $args);

            };

        endif;

        /* return modify args */
        return $args;

    }

    /**
     * @param $comment
     * @param bool $depth
     * @param bool $args
     */
    public static function comment_template($comment, $depth = false, $args = false)
    {

        /* check if comment exists */
        if ($comment):

            ?>

            <!-- comment -->
            <li id="comment-<?php comment_ID(); ?>" <?php comment_class(empty($args['has_children']) ? '' : 'parent', $comment); ?>>

                <!-- comment body -->
                <div class="comment-body">

                    <!-- author avatar -->
                    <div class="author-avatar">

                        <?php

                        /* check if avatar size is empty */
                        if (empty($args['avatar_size'])):

                            /* avatar size */
                            $avatar_size = 100;

                        else:

                            /* avatar size */
                            $avatar_size = $args['avatar_size'];

                        endif;

                        /* output avatar */
                        echo get_avatar($comment, $avatar_size);

                        /* unset avatar size */
                        unset($avatar_size);

                        ?>

                    </div>

                    <!-- comment content -->
                    <div class="comment-content">

                        <div class="name-wrapper">

                            <!-- author name -->
                            <h6 class="author-name">

                                <?php

                                /* comment author link */
                                comment_author_link();

                                ?>

                            </h6>

                            <!-- date wrapper -->
                            <div class="date-wrapper">

                                <!-- date -->
                                <p class="date">

                                    <?php

                                    /* output comment date */
                                    printf(esc_html('%1$s at %2$s'), get_comment_date(), get_comment_time());

                                    ?>

                                </p>

                                <?php

                                /* output edit comment link */
                                edit_comment_link(esc_html__('Edit', 'qreatix'),
                                    '<p class="edit-button">',
                                    '</p>');

                                ?>

                            </div>

                        </div>

                        <!-- comment text -->
                        <div class="comment-text entry-content">

                            <?php

                            /* output comment text */
                            comment_text();

                            /* output comment reply link */
                            comment_reply_link(array(
                                'reply_text' => esc_html__('Reply', 'qreatix'),
                                'depth' => 5,
                                'max_depth' => 10,
                                'before' => '<span class="reply-link-wrapper">',
                                'after' => '</span>'
                            ), $comment);

                            ?>

                        </div>

                        <?php if ('0' == $comment->comment_approved) : ?>

                            <!-- comment awaiting moderation -->
                            <p class="comment-awaiting-moderation">

                                <?php echo esc_html__('Your comment is awaiting moderation.', 'qreatix'); ?>

                            </p>

                        <?php endif; ?>

                    </div>

                </div>

            </li>

        <?php

        endif;

    }

    /**
     * @param $str
     *
     * @return mixed
     */
    public static function check_for_empty($str)
    {

        /* check if string is empty */
        if (!empty($str)):

            /* return string */
            return $str;

        endif;

    }

    /**
     * @param $title
     *
     * @return mixed
     */
    public function remove_sitename_from_title($title)
    {

        /* remove sitename from the array */
        unset($title['site']);

        /* return title */
        return $title;

    }

    /**
     * @param $attachment_id
     * @param $size
     * @param $attr
     * @param bool $wrapper
     * @param string $wrapper_class
     *
     * @return string
     */
    public static function render_image($attachment_id, $size, $classes = '')
    {

        $html = '';

        $meta = wp_get_attachment_metadata($attachment_id);

        $attr = array(
            'sizes' => wp_get_attachment_image_sizes($attachment_id, $size, $meta),
            'srcset' => wp_get_attachment_image_srcset($attachment_id, $size, $meta),
            'title' => get_the_title($attachment_id),
            'alt' => get_the_title($attachment_id),
            'class' => $classes,
            'loading' => 'lazy'
        );

        if (!empty($meta['sizes'][$size])):

            $attr['width'] = $meta['sizes'][$size]['width'];

            $attr['height'] = $meta['sizes'][$size]['height'];

        endif;

        $html .= wp_get_attachment_image($attachment_id, $size, false, $attr);

        if (!empty($html)):

            return $html;

        endif;

    }


    /**
     * @return mixed
     */
    public function set_products_per_page()
    {


        if (!empty($_GET['count'])):

            return $_GET['count'];

        else:

            return get_theme_mod('shop-number-of-items', 12);

        endif;

    }

    /**
     * @return mixed
     */
    public function set_columns_count()
    {

        if (!empty($_GET['columns'])):

            return $_GET['columns'];

        else:

            return get_theme_mod('shop-number-of-grid-column', 4);

        endif;


    }

    /**
     * @param $fields
     *
     * @return mixed
     */
    public function override_billing_checkout_fields($fields)
    {

        /* billing phone field */
        $fields['billing']['billing_phone']['placeholder'] = esc_html__('Phone (optional)', 'qreatix');

        /* billing email field */
        $fields['billing']['billing_email']['placeholder'] = esc_html__('Email Address', 'qreatix');

        /* return modified fields */
        return $fields;

    }

    /**
     * @param $address_fields
     *
     * @return mixed
     */
    public function override_default_address_checkout_fields($address_fields)
    {

        /* address name field */
        $address_fields['first_name']['placeholder'] = esc_html__('First Name', 'qreatix');

        /* address last name field */
        $address_fields['last_name']['placeholder'] = esc_html__('Last Name', 'qreatix');

        /* address 1 field */
        $address_fields['address_1']['placeholder'] = esc_html__('Address', 'qreatix');

        /* address company field */
        $address_fields['company']['placeholder'] = esc_html__('Company Name (optional)', 'qreatix');

        /* address state field */
        $address_fields['state']['placeholder'] = esc_html__('State / Country', 'qreatix');

        /* address country field */
        $address_fields['country']['placeholder'] = esc_html__('Select Country', 'qreatix');

        /* address postcode field */
        $address_fields['postcode']['placeholder'] = esc_html__('Postcode / Zip', 'qreatix');

        /* address city field */
        $address_fields['city']['placeholder'] = esc_html__('Town / City', 'qreatix');

        /* return modified fields */
        return $address_fields;

    }

    /**
     *
     */
    public function woocommerce_template_loop_add_to_cart()
    {

        woocommerce_template_loop_add_to_cart();

    }


    /**
     *
     */
    public function woocommerce_template_loop_rating()
    {

        global $product;

        if (!empty(wc_get_rating_html($product->get_average_rating()))):

            ?>

            <div class="rating-wrapper">

                <?php wc_get_template('single-product/rating.php'); ?>

            </div>

        <?php

        endif;

    }


    /**
     *
     */
    public function woocommerce_output_all_notices()
    {

        echo '<div class="woocommerce-notices-wrapper">';

        wc_print_notices();

        echo '</div>';

    }

    /**
     *
     */
    public function change_products_loop_title()
    {

        echo '<h5 class="' . esc_attr(apply_filters('woocommerce_product_loop_title_classes', 'woocommerce-loop-product__title')) . '"><a href="' . get_the_permalink() . '" class="multiline-hover">' . get_the_title() . '</a></h5>';

    }

    /**
     *
     */
    public function shop_load_more()
    {

        wp_reset_postdata();

        $count = get_theme_mod('shop-number-of-items', 12);

        if (!empty($_GET['count'])):

            $count = $_GET['count'];

        endif;

        $args = array(
            'post_type' => 'product',
            'paged' => $_POST['paged'] + 1,
            'posts_per_page' => $count
        );

        $loop = new WP_Query($args);

        if ($loop->have_posts()) :

            while ($loop->have_posts()) : $loop->the_post();

                wc_get_template_part('content', 'product');

            endwhile;

        endif;

        wp_reset_postdata();

        die();

    }

    /**
     * @return string|void
     */
    public function override_order_button_text()
    {

        /* new order button text */
        return esc_html__('Apply Now', 'qreatix');

    }

    /**
     * @return mixed
     */
    public function output_cross_sells_products()
    {

        if (!empty($_GET['cross_sells_count'])):

            return $_GET['cross_sells_count'];

        else:

            return get_theme_mod('shop-number-of-cross-sells-items', 5);

        endif;

    }

    /**
     * @param $args
     *
     * @return array
     */
    public function output_related_products($args)
    {

        /* related products args */
        $args = array(

            'posts_per_page' => get_theme_mod('shop-number-of-related-items', 5),

        );

        /* return args */
        return $args;

    }

    /**
     * @param $args
     *
     * @return array
     */
    public function output_upsell_products($args)
    {

        if (!empty($_GET['upsells_items'])):

            $args = array(

                'posts_per_page' => $_GET['upsells_items'],

            );

        else:

            $args = array(

                'posts_per_page' => get_theme_mod('shop-number-of-upsells-items', 5),

            );

        endif;

        return $args;

    }

    /**
     * add_admin_menu_page
     */
    public function add_admin_menu_page()
    {

        add_menu_page(

        /* page title */
            $this->name . esc_html__(' Dashboard', 'qreatix'),
            /* menu title */
            $this->menu_title . esc_html__(' Dashboard', 'qreatix'),
            /* capability */
            $this->capability,
            /* menu slug */
            $this->slug,
            /* handler method */
            [$this, 'shell'],
            /* menu icon */
            'data:image/svg+xml;base64,' . base64_encode($this->icon_svg),
            /* menu position */
            $this->position

        );

    }

    /**
     *
     */
    public function shell()
    {

        self::$instance->shell(array(
            /* item logotype */
            'logo_svg' => $this->logo_svg,
            /* item name */
            'name' => $this->name,
            /* item slug */
            'slug' => $this->slug,
            /* item version */
            'version' => $this->version,
            /* item additional links */
            'additional_links' => $this->additional_links,
            /* item social_links */
            'social_links' => $this->social_links,
            /* item tabs */
            'tabs' => $this->tabs,
            /* item copyright */
            'copyright' => $this->copyright,
            /* item author */
            'author' => $this->author,
            /* item author url */
            'author_url' => $this->author_url,
            /* item url */
            'item_url' => $this->item_url,
            /* item default tab */
            'default_tab' => $this->default_tab,
            /* item notices callback */
            'notices_callback' => function () {


            },
        ));

    }

}
