<?php defined('ABSPATH') || exit;
/*
 *
 */

/* check if password required */
if (post_password_required()) :

    /* exit */
    return;

endif;

/* get ajax comments toggle option */
$ajax_comments = get_theme_mod('comments-ajax-submission-toggle', esc_attr('1'));

/* set ajax comments from $_GET */
if (!empty($_GET['ajax_comments']) && $_GET['ajax_comments'] === 'on'):

    /* set true */
    $ajax_comments = true;

endif;

/* set ajax comments from $_GET */
if (!empty($_GET['ajax_comments']) && $_GET['ajax_comments'] === 'off'):

    /* set false */
    $ajax_comments = false;

endif;

/* comments pagination */
$comments_pagination = get_theme_mod('comments-pagination-type', esc_attr('default'));

/* comments pagination from $_GET */
if (!empty($_GET['comments_pagination'])):

    /* set comments pagination */
    $comments_pagination = $_GET['comments_pagination'];

endif;

/* get cpage value */
$cpage = get_query_var('cpage') ? get_query_var('cpage') : 1;

/* check if core class exists */
if (class_exists('JKD_Core')):

    /* enqueue comments script */
    wp_enqueue_script(JKD_Core::$prefix . 'comments');

    /* enqueue comments style */
    wp_enqueue_style(JKD_Core::$prefix . 'comments');

endif;

/* empty classes array */
$classes = array();

/* check if ajax comments exists */
if ($ajax_comments):

    /* push to classes 'ajax-comments' */
    array_push($classes, 'ajax-comments');

endif;

/* check if option show avatars is true */
if (get_option('show_avatars')):

    /* push to classes 'ajax-comments' */
    array_push($classes, 'show-avatars');

endif;

/* implode array to string */
$classes = implode(' ', $classes);

?>

<!-- comments area -->
<div id="comments" class="comments-area <?php echo esc_attr($classes); ?>">

    <?php

    /* check if have_comments === true */
    if (have_comments()) :

        ?>

        <!-- comment list -->
        <ol class="comment-list">

            <?php

            /* list comments */
            wp_list_comments(
                array(
                    'avatar_size' => 60,
                    'style' => 'ol',
                    'short_ping' => true,
                )
            );

            ?>

        </ol>

        <?php

        /* check if comments pages > 1 */
        if ($cpage > 1):

            /* if comments pagination type === default */
            if ($comments_pagination === 'default'):

                ?>

                <!-- jkd-pagination -->
                <div class="jkd-pagination">

                    <?php

                    $rtl = get_theme_mod('general-rtl-toggle', false);

                    if (!empty($_GET['rtl'])):

                        $rtl = $_GET['rtl'];

                    endif;

                    if ($rtl):

                        /* comments pagination */
                        the_comments_pagination(
                            array(
                                'before_page_number' => '',
                                'end_size' => 1,
                                'mid_size' => 1,
                                'prev_text' => '<div class="pagination-arrow prev-arrow">' . '<i class="ri-arrow-right-line"></i>' . esc_html__('Previous', 'qreatix') . '</div>',
                                'next_text' => '<div class="pagination-arrow next-arrow">' . esc_html__('Next', 'qreatix') . '<i class="ri-arrow-left-line"></i>' . '</div>',
                            )
                        );

                    else:

                        /* comments pagination */
                        the_comments_pagination(
                            array(
                                'before_page_number' => '',
                                'end_size' => 1,
                                'mid_size' => 1,
                                'prev_text' => '<div class="pagination-arrow prev-arrow">' . '<i class="ri-arrow-left-line"></i>' . esc_html__('Previous', 'qreatix') . '</div>',
                                'next_text' => '<div class="pagination-arrow next-arrow">' . esc_html__('Next', 'qreatix') . '<i class="ri-arrow-right-line"></i>' . '</div>',
                            )
                        );

                    endif;

                    ?>

                </div>

            <?php

            /* if comments pagination type === load-more */
            elseif ($comments_pagination === 'load-more'):

                ?>

                <!-- jkd-pagination load-more-button -->
                <div class="jkd-pagination load-more-wrapper">

                    <!-- load-more-button -->
                    <button class="comments-load-more jkd-button default-border-style animation-fill size-extra-small">

                        <?php echo esc_html__('Load More...', 'qreatix'); ?>

                    </button>

                </div>

            <?php

            endif;

        endif;

        /* check if comments is not open */
        if (!comments_open()) : ?>

            <!-- no comments -->
            <p class="no-comments">

                <?php echo esc_html__('Comments are closed.', 'qreatix'); ?>

            </p>

        <?php

        endif;

    endif;

    /* comments form */
    comment_form(
        array(
            'logged_in_as' => null,
            'title_reply' => esc_html__('Leave a comment', 'qreatix'),
            'title_reply_before' => '<h2 id="reply-title" class="comment-reply-title">',
            'title_reply_after' => '</h2>',
        )
    );

    ?>

</div>
