<?php defined('ABSPATH') || exit;

if (!defined('THEME_SLUG')):

    define('THEME_SLUG', 'qreatix-wp');

endif;

/* include JKD_Theme class */
require_once(get_template_directory() . '/class-jkd-theme.php');

/* theme instance */
$Theme = new JKD_Theme(array(

    /* slug */
    'slug' => 'qreatix-wp',

    /* plugin author */
    'author' => 'jkdevstudio',

    /* author url */
    'author_url' => 'https://jk-studio-dev.com/',

    /* codecanyon id */
    'id' => '31728964',

    /* theme version */
    'version' => wp_get_theme()['Version'],

    /* item url */
    'item_url' => esc_url('https://themeforest.net/item/qreatix-interactive-portfolio-wordpress-theme/31728964'),

    /* name */
    'name' => esc_html('Qreatix'),

    /* menu title */
    'menu_title' => esc_html('Qreatix'),

    /* admin capability */
    'capability' => 'edit_theme_options',

    /* self hosted repo url */
    'assets_url' => esc_url('https://jk-studio-dev.com/updates/themes/qreatix/'),

    /* github repo slug */
    'update_repo_slug' => 'qreatix',

    /* github local update path */
    'update_local_path' => get_template_directory(),

    /* github repo url */
    'update_repo_url' => 'https://jk-studio-dev.com/updates/themes/qreatix/theme/theme.json',

    /* shell logo svg */
    'logo_svg' => '<svg xmlns="http://www.w3.org/2000/svg" width="35px" height="35px" viewBox="0 0 35 35"><path style=" stroke:none;fill-rule:nonzero;fill:rgb(7.843137%,9.411765%,15.294118%);fill-opacity:1;" d="M 17.5 0 C 7.835938 0 0 7.835938 0 17.5 C 0 27.164062 7.835938 35 17.5 35 C 27.164062 35 35 27.164062 35 17.5 C 35 7.835938 27.164062 0 17.5 0 Z M 17.5 29.898438 C 10.65625 29.898438 5.101562 24.347656 5.101562 17.5 C 5.101562 10.652344 10.65625 5.101562 17.5 5.101562 C 24.34375 5.101562 29.898438 10.65625 29.898438 17.5 C 29.898438 24.34375 24.34375 29.898438 17.5 29.898438 Z M 17.5 29.898438 "/>
<path style=" stroke:none;fill-rule:nonzero;fill:rgb(7.843137%,9.411765%,15.294118%);fill-opacity:1;" d="M 19.6875 23.332031 L 23.332031 19.691406 L 28.4375 24.796875 L 24.792969 28.4375 Z M 19.6875 23.332031 "/></svg>',

    /* icon logo svg */
    'icon_svg' => '<svg xmlns="http://www.w3.org/2000/svg" width="18px" height="18px" viewBox="0 0 18 18"><path style=" stroke:none;fill-rule:nonzero;fill:rgb(100%,100%,100%);fill-opacity:1;" d="M 9 0 C 4.03125 0 0 4.03125 0 9 C 0 13.96875 4.03125 18 9 18 C 13.96875 18 18 13.96875 18 9 C 18 4.03125 13.96875 0 9 0 Z M 9 15.375 C 5.480469 15.375 2.625 12.523438 2.625 9 C 2.625 5.476562 5.480469 2.625 9 2.625 C 12.519531 2.625 15.375 5.480469 15.375 9 C 15.375 12.519531 12.519531 15.375 9 15.375 Z M 9 15.375 "/><path style=" stroke:none;fill-rule:nonzero;fill:rgb(100%,100%,100%);fill-opacity:1;" d="M 10.125 12 L 12 10.125 L 14.625 12.75 L 12.75 14.625 Z M 10.125 12 "/></svg>',

    /* admin page position */
    'position' => 49,

    /* local url */
    'url' => trailingslashit(get_template_directory_uri()),

    /* local path */
    'path' => get_template_directory(),

    /* templates path */
    'templates_path' => WP_PLUGIN_DIR . '/jkd-wp-qreatix-core/templates/',

    /* plugin copyright */
    'copyright' => esc_html('© ' . date("Y") . ', ' . esc_html('Qreatix') . '. Made with ❤️'),

    /* default tab */
    'default_tab' => 'license',

    /* tabs */
    'tabs' => array(

        /* License Tab (general) */
        'license' => esc_html__('License', 'qreatix'),

        /* Changelog Tab (general) */
        'changelog' => esc_html__('Changelog', 'qreatix'),

        /* Tools Tab (general) */
        'tools' => esc_html__('Tools', 'qreatix'),

        /* Status Tab (general) */
        'status' => esc_html__('Status', 'qreatix'),
    ),

    /* need help links */
    'additional_links' => array(

        /* item link */
        array(
            'title' => esc_html__('Item Link', 'qreatix'),
            'icon' => 'ri-link',
            'url' => esc_url('https://themeforest.net/item/qreatix-interactive-portfolio-wordpress-theme/31728964')
        ),

        /* support link */
        array(
            'title' => esc_html__('Support Forum', 'qreatix'),
            'icon' => 'ri-service-line',
            'url' => esc_url('https://jkdevstudio.ticksy.com/')
        ),

        /* docs link */
        array(
            'title' => esc_html__('Documentation', 'qreatix'),
            'icon' => 'ri-file-copy-2-line',
            'url' => esc_url('https://jk-studio-dev.com/docs/qreatix/')
        ),

    ),

    /* social links */
    'social_links' => array(

        /* dribbble */
        array(
            'title' => esc_html__('Dribbble', 'qreatix'),
            'icon' => 'ri-dribbble-line',
            'url' => esc_url('https://dribbble.com/jkdevstudio')
        ),

        /* behance */
        array(
            'title' => esc_html__('Behance', 'qreatix'),
            'icon' => 'ri-behance-line',
            'url' => esc_url('https://www.behance.net/jkdevstudio')
        ),

        /* github */
        array(
            'title' => esc_html__('Github', 'qreatix'),
            'icon' => 'ri-github-line',
            'url' => esc_url('https://github.com/alexposlushnyak')
        ),

        /* Upwork */
        array(
            'title' => esc_html__('Upwork', 'qreatix'),
            'icon' => 'ri-coin-line',
            'url' => esc_url('https://www.upwork.com/freelancers/alexposlushnyak')
        ),

        /* E-Mail */
        array(
            'title' => esc_html__('E-Mail', 'qreatix'),
            'icon' => 'ri-mail-line',
            'url' => esc_url('mailto:contact.alexander.poslushnyak@gmail.com')
        ),

    )
));
