<?php defined('ABSPATH') || exit;
/*
 *
 */

/* check if JKD_Core exists */
if (class_exists('JKD_Core')):

    /* render loop-start template */
    JKD_Core::template('global/loop-start');

else:

    ?>

    <!-- body -->
    <body <?php body_class(); ?>>

    <?php

    /* wp_body_open */
    wp_body_open();

    /* include navigation */
    get_template_part('template-parts/navigation/navigation');

    ?>

    <!-- main wrapper -->
    <main class="main-wrapper default-wrapper">

<?php

endif;

if (class_exists('WooCommerce')):

    /* additional woocommerce check */
    if (is_cart() || is_checkout() || is_account_page() || is_product() || is_shop() || is_product_taxonomy()):

        /* reset postdata */
        wp_reset_postdata();

        if (is_shop() || is_product_taxonomy()):

            $shop_header_trigger = get_theme_mod('shop-header', 1);

            $shop_header_type = get_theme_mod('shop-header-type', 'default');

        endif;

        $product_type = get_theme_mod('shop-single-product-type', esc_attr('default'));

        if (!empty($_GET['product_type'])):

            $product_type = $_GET['product_type'];

        endif;

        $classes = array();

        if (is_shop() || is_product_taxonomy()):

            array_push($classes, 'shop-wrapper');

        endif;

        if (is_product()):

            array_push($classes, 'product-wrapper');

            array_push($classes, 'product-' . esc_attr($product_type));

        endif;

        if (is_checkout()):

            array_push($classes, 'checkout-wrapper');

        endif;

        if (is_cart() && !WC()->cart->is_empty()):

            array_push($classes, 'cart-wrapper');

        endif;

        if (is_account_page()):

            array_push($classes, 'account-wrapper');

            if (is_user_logged_in()):

                array_push($classes, 'log-in');

            endif;

        endif;

        $classes = implode(' ', $classes);

        ?>

        <div class="woocommerce-wrapper <?php echo esc_attr($classes); ?>">

        <?php

        $banner_toggle = get_theme_mod('shop-banner-toggle', 1);

        if (!empty($_GET['banner'])):

            $banner_toggle = $_GET['banner'];

        endif;

        if ($banner_toggle && class_exists('JKD_Core')):

            if ((is_product() && $product_type === 'default') || !is_product()):

                JKD_Core::template('shop/banner');

            endif;

        endif;

        ?>

        <div class="entire-content-wrapper">

        <div class="inner-wrapper
            <?php if ((is_product() && $product_type === 'default') || !is_product()): ?>container<?php endif; ?>">

    <?php

    endif;

    if (function_exists('tinv_get_option_defaults')):

        if (is_wishlist() && get_the_permalink() === tinv_url_wishlist_default()):

            ?>

            <div class="woocommerce-wrapper wishlist-wrapper">

            <?php

            $banner_toggle = get_theme_mod('shop-banner-toggle', 1);

            if (!empty($_GET['banner'])):

                $banner_toggle = $_GET['banner'];

            endif;

            if ($banner_toggle && class_exists('JKD_Core')):

                if ((is_product() && $product_type === 'default') || !is_product()):

                    JKD_Core::template('shop/banner');

                endif;

            endif;

            ?>

            <div class="entire-content-wrapper">

                <div class="inner-wrapper container">

        <?php

        endif;

    endif;

endif;

?>
