<?php defined('ABSPATH') || exit;
/*
 *
 */

/* define wp_query */
global $wp_query;

/* get total results */
$total_results = $wp_query->found_posts;

?>

    <!-- navigation -->
    <nav class="navigation">

        <!-- inner-wrapper -->
        <div class="inner-wrapper container">

            <!-- logotype -->
            <div class="logotype">

                <h5 class="website-name">

                    <!-- website link -->
                    <a href="<?php echo esc_url(home_url('/')); ?>">

                        <?php echo esc_html(get_bloginfo('name')); ?>

                    </a>

                </h5>

            </div>

            <?php

            /* check if primary_menu is exists */
            if (has_nav_menu('primary_menu')) :

                ?>

                <!-- menu-side -->
                <div class="menu-side">

                    <!-- menu-list-wrapper -->
                    <div class="menu-list-wrapper">

                        <?php

                        /* output primary_menu */
                        wp_nav_menu(array(
                            'theme_location' => 'primary_menu',
                            'menu' => 'primary_menu',
                            'menu_class' => 'menu-list',
                            'container' => '',
                        ));

                        ?>

                    </div>

                </div>

            <?php endif; ?>

        </div>

    </nav>

    <!-- mobile navigation -->
    <nav class="mobile-navigation">

        <!-- inner-wrapper -->
        <div class="inner-wrapper container">

            <!-- logotype -->
            <div class="logotype">

                <h5 class="website-name">

                    <!-- website link -->
                    <a href="<?php echo esc_url(home_url('/')); ?>">

                        <?php echo esc_html(get_bloginfo('name')); ?>

                    </a>

                </h5>

            </div>

            <!-- menu-toggle -->
            <div class="menu-toggle">

                <!-- default-icon -->
                <i class="ri-menu-line menu-icon"></i>

                <!-- close-icon -->
                <i class="ri-close-line close-icon"></i>

            </div>

        </div>

        <?php

        /* check if primary_menu is exists */
        if (has_nav_menu('primary_menu')) :

            ?>

            <!-- menu-list-overlay -->
            <div class="menu-list-overlay">

                <?php

                /* output primary_menu */
                wp_nav_menu(array(
                    'theme_location' => 'primary_menu',
                    'menu' => 'primary_menu',
                    'menu_class' => 'menu-list',
                    'container' => '',
                ));

                ?>

            </div>

        <?php endif; ?>

    </nav>

<?php

/* check if is_404 and !is_single */
if (!is_404() && !is_search()):

    ?>

    <!-- page-header -->
    <header class="page-header">

        <!-- inner-wrapper -->
        <div class="inner-wrapper container">

            <!-- page-title -->
            <h1 class="page-title extra-h1">

                <?php

                /* check if is_home */
                if (is_home()):

                    /* output website name */
                    echo esc_html(bloginfo('name'));

                /* check if is_search */
                elseif (is_search()):

                    /* echo search results title */
                    echo esc_html__('Search Results', 'qreatix');

                /* check if is_archive */
                elseif (is_archive()):

                    /* echo archive title */
                    echo get_the_archive_title();

                /* check if is_404 */
                elseif (is_404()):

                    /* echo page not found title */
                    echo esc_html__('Page not Found', 'qreatix');

                else:

                    /* check document title */
                    echo wp_get_document_title();

                endif;

                ?>

            </h1>

            <?php

            /* check if is_home */
            if (is_home()):

                ?>

                <!-- subtitle -->
                <p class="subtitle">

                    <?php

                    /* echo site description */
                    echo esc_html(bloginfo('description')); ?>

                </p>

            <?php

            endif;

            /* check if is_search  */
            if (is_search()): ?>

                <!-- total-results -->
                <p class="total-results">

                    <?php

                    /* total results title */
                    echo esc_html__('Total Results: ', 'qreatix') . esc_html($total_results);

                    ?>

                </p>

            <?php endif; ?>

        </div>

    </header>

<?php

endif;

/* check if is_search and total results === 0 */
if (is_search() && $total_results === 0):

    /* include not found template */
    get_template_part('template-parts/additional/not-found');

endif;
