<?php
/*
 *
 */

/**
 * Cross-sells
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/cart/cross-sells.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce\Templates
 * @version 4.4.0
 */

defined('ABSPATH') || exit;

$cross_sells_toggle = get_theme_mod('shop-cross-sells-products', esc_attr('1'));

if (!empty($_GET['cross_sells'])):

    $cross_sells_toggle = $_GET['cross_sells'];

endif;

if ($cross_sells && $cross_sells_toggle) : ?>

    <div class="product-slider-wrapper cross-sells-wrapper bottom-item"
         data-slider-type="<?php echo esc_attr('cross-sells'); ?>"
         data-slides="<?php echo esc_attr('2'); ?>">

        <section class="product-slider-inner">
            <?php

            $heading = apply_filters('woocommerce_product_cross_sells_products_heading', __('Cross-Sells Products', 'qreatix'));

            if (!empty($heading)):

                ?>

                <div class="cross-sells-header product-slider-header">

                    <?php if ($heading) : ?>

                        <div class="title-wrapper">

                            <div class="pagination-numbers">

                            </div>

                            <h5 class="cross-sells-title product-slider-title">

                                <?php echo esc_html($heading); ?>

                            </h5>

                        </div>

                    <?php endif; ?>

                    <div class="cross-sells-navigation product-slider-navigation">

                        <div class="navigation-button navigation-button-prev">

                            <i class="ri-arrow-drop-left-line"></i>

                        </div>

                        <div class="navigation-button navigation-button-next">

                            <i class="ri-arrow-drop-right-line"></i>

                        </div>

                    </div>

                </div>

            <?php endif; ?>

            <div class="swiper-container cross-sells-slider product-slider">

                <div class="swiper-wrapper">

                    <?php foreach ($cross_sells as $cross_sell) : ?>

                        <div class="swiper-slide">

                            <?php

                            $id = $cross_sell->get_id();

                            $product = wc_get_product($id);

                            $thumbnail_id = get_post_thumbnail_id($id);

                            $product_title = $product->get_title();

                            $product_price = $product->get_price_html();

                            $product_permalink = $product->get_permalink();

                            ?>

                            <div class="product-slide-inner">

                                <a href="<?php echo esc_url($product_permalink); ?>" class="link-overlay"></a>

                                <?php if (!empty($thumbnail_id)): ?>

                                    <a class="thumbnail-wrapper" href="<?php echo esc_url($product_permalink); ?>">

                                        <?php

                                        if (class_exists('JKD_Helper')):

                                            echo JKD_Theme::render_image($thumbnail_id,
                                                'jk-square-size-extra-small');

                                        else:

                                            ?>

                                            <img src="<?php echo esc_url(wp_get_attachment_image_url($thumbnail_id, 'thumbnail')) ?>"
                                                 alt="<?php echo esc_html(get_the_title()); ?>">

                                        <?php

                                        endif;

                                        ?>

                                    </a>

                                <?php endif; ?>

                                <div class="product-body">

                                    <h6 class="product-title">

                                        <?php echo esc_html($product_title); ?>

                                    </h6>

                                    <div class="price-wrapper">

                                        <?php echo JKD_Theme::check_for_empty($product_price); ?>

                                    </div>

                                </div>

                            </div>

                        </div>

                    <?php endforeach; ?>

                </div>

            </div>

        </section>

    </div>
<?php
endif;

wp_reset_postdata();
